import Koa from 'koa'
import dotenv from 'dotenv'
import route from 'koa-route'
import Debug from 'debug'
import koaBody from 'koa-body'
import func from './func'

dotenv.config()
console.log = Debug('invoiceIssuer:app.ts')

const app = new Koa()
app.use(koaBody())

app.use(route.get('/', (ctx) => {
	ctx.body = 'Hello World'
}))

app.use(route.post('/payer', async (ctx) => {
	// TODO: 请求头验证 bearer token
	
	const { name, address, email, abn } = ctx.request.body
	if (!name || !address || !email) {
		ctx.throw(400, 'required_fields_missing')
	}

	try {
		const payer = await func.createPayer(name, address, email, abn)
		ctx.body = payer
	} catch (e) {
		if (e instanceof HttpError) {
			ctx.status = e.status
			ctx.body = e.message
		} else {
			console.error(e)
			ctx.throw(500, 'unknown_issues')
		}
	}
}))

const port = parseInt(process.env.PORT ?? '3000')
app.listen(port, () => {
	console.log(`Server is running at http://localhost:${port}`)
})