/**
 * 用于规范化向用户返回的错误信息。信息与状态码皆为枚举类型，以便前端进行 i18n、保证错误信息的准确性，
 * 同时保证返回的格式符合 HTTP 规范。
 */
class HttpError extends Error {
	/**
	 * 创建一个新的 HTTP 错误。
	 * @param message 错误的消息。
	 * @param status 错误的状态码。
	 */
	constructor(message: 'required_fields_missing' | 'unknown_issues', status: number);
	status: 400 | 401 | 403 | 404 | 500;
}